Mail::Box::MH::Index(3pm)

NAME
Mail::Box::MH::Index - keep index files for messages.

INHERITANCE
 Mail::Box::MH::Index
   is a Mail::Reporter

SYNOPSIS
  my $index = Mail::Box::MH::Index->new;
  $index->read(...)
  $index->write(...)

DESCRIPTION
Message folders which store their data in one single file per message are very inefficient for producing subject overviews and for computing message threads. The "Mail::Box::MH::Index" object is able to store and read a the headers of a set of "Mail::Box::MH::Message" messages which are part of a single "Mail::Box::MH" folder in one file.

When the "Mail::Box::MH::Index" functionality is enabled by specifying Mail::Box::MH::new(keep_index) when opening a folder, the index file is automatically read. When the folder is closed, a new index file is created.

Special care is taken to avoid problems which occur when the user changes or removes message files without updating the index. If the index is not trustworthy it will not be used (costing some performance for the reader of the folder).

Extends "DESCRIPTION" in Mail::Reporter.

METHODS
Extends "METHODS" in Mail::Reporter.

  Constructors
Extends "Constructors" in Mail::Reporter.

$class->new(%options)
    Inherited, see "Constructors" in Mail::Reporter

     -Option   --Default
      filename   <required>
      head_type  Mail::Message::Head::Subset
      head_wrap  72

    filename => $file
        The $file which is used to store the headers of all the e-mails for one folder. This must be an absolute pathname.

    head_type => $class
        The type of headers which will be used to store header information when it is read from the index file. You can not be sure the index contains all header line (the mailbox may have been updated without updating the index) so this will usually be (an sub-class of) Mail::Message::Head::Subset.

    head_wrap => $nrchars
        The preferred maximum number of characters in each header line.

  Attributes
Extends "Attributes" in Mail::Reporter.

$obj->filename()
    Returns the name of the index file.

  Error handling
Extends "Error handling" in Mail::Reporter.

$obj->AUTOLOAD()
    Inherited, see "Error handling" in Mail::Reporter

$obj->notImplemented()
    Inherited, see "Error handling" in Mail::Reporter

  Cleanup
Extends "Cleanup" in Mail::Reporter.

$obj->DESTROY()
    Inherited, see "Cleanup" in Mail::Reporter

  The Index

$obj->append(@messages)
    Append @messages to the index file.

$obj->get($msgfile)
    Look if there is header info for the specified $msgfile. The filename represents one message in folder type which are organized as directory. This method will return an object of the new(head_type) as specified during creation of the index object, or "undef" if the information is not known or not trustworthy -i.e. the file size changed.

$obj->read()
    Read the index file. The header objects can after this be requested with the get() method.

$obj->write(@messages)
    Write an index file containing the headers specified @messages (Mail::Message objects).

DIAGNOSTICS

Error: MH index requires a filename.
    Cast by new()

Error: class $package does not implement method $method.
    Fatal error: the specific $package (or one of its superclasses) does not implement this method where it should. This message means that some other related classes do implement this method however the class at hand does not. Probably you should investigate this and probably inform the author of the package. Cast by notImplemented()

SEE ALSO
This module is part of Mail-Box version 4.02, built on April 10, 2026. Website: http://perl.overmeer.net/CPAN/

LICENSE
For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under the same terms as the Perl 5 programming language system itself.